<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdklogincheck.jsp" %>

<%@ page import="com.esko.webcenter.src.root.*" %>
<%@ page import="com.esko.webcenter.src.root.view.*"%>
<%@ page import="com.esko.webcenter.log.LogMgr" %>
<%@ page import="com.esko.util.StringUtils" %>
<%@ page import="com.eskographics.wc.ejb.WebCenterRemoteException" %>
<%@ page import="com.esko.webcenter.exceptions.DeleteMemberException" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.util.Map.Entry" %>
<%@ page import="com.esko.webcenter.cache.ProjectStatusesCache" %>
<%@ page import="com.esko.webcenter.jsp.ProjectNotificationMgr" %>
<%@ page import="com.esko.util.VectorUtils" %>
<%@ page import="java.sql.Timestamp" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.text.DateFormat" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.text.ParseException"%>
<%@ page import="java.util.Date" %>
<%@ page import="com.esko.webcenter.jdf.ExportToJDF"%>

<%
	String loginID = LoginMgr.getLoginMgr(session).getLoginID();
	
	// action parameter constants
	final String ACTION_CREATE = "create";
	final String ACTION_MODIFY = "modify";
		
	// get the project creation params 	
	Properties requestParams = SDKUtils.getRequestParams(request, session, application, requestParamsLoginCheck);
	
	String projectName = (requestParams.containsKey("projectname")) ? ((String[])requestParams.get("projectname"))[0] : null;
	String projectNewName = (requestParams.containsKey("renameto")) ? ((String[])requestParams.get("renameto"))[0].trim() : "";
	String projectNameSuffix = (requestParams.containsKey("projectnamesuffix")) ? ((String[])requestParams.get("projectnamesuffix"))[0] : null;
	String projectID = (requestParams.containsKey("projectid")) ? ((String[])requestParams.get("projectid"))[0] : null;
	String action = (requestParams.containsKey("action")) ? ((String[])requestParams.get("action"))[0] : null;
	String projectDesc = (requestParams.containsKey("projectdescription")) ? ((String[])requestParams.get("projectdescription"))[0] : null;
	String projectTemplateID = (requestParams.containsKey("projecttemplateid")) ? ((String[])requestParams.get("projecttemplateid"))[0] : "";
	String projectTemplateName = (requestParams.containsKey("projecttemplatename")) ? ((String[])requestParams.get("projecttemplatename"))[0] : "";
	String copyProjectID = (requestParams.containsKey("copyprojectid")) ? ((String[])requestParams.get("copyprojectid"))[0] : "";
	String copyProjectName = (requestParams.containsKey("copyprojectname")) ? ((String[])requestParams.get("copyprojectname"))[0] : "";
	String managerID = (requestParams.containsKey("managerid")) ? ((String[])requestParams.get("managerid"))[0] : "";
	String managerName = (requestParams.containsKey("managername")) ? ((String[])requestParams.get("managername"))[0] : "";
	String isMgrGroupStr = (requestParams.containsKey("ismanagergroup")) ? ((String[])requestParams.get("ismanagergroup"))[0] : "";
	boolean isMgrGroup = isMgrGroupStr.equalsIgnoreCase("1");
	String companyID = (requestParams.containsKey("customercompanyid")) ? ((String[])requestParams.get("customercompanyid"))[0] : "";
	String companyShortName = (requestParams.containsKey("customercompanycode")) ? ((String[])requestParams.get("customercompanycode"))[0] : "";
	String companyName = (requestParams.containsKey("customercompanyname")) ? ((String[])requestParams.get("customercompanyname"))[0] : "";
	String salesPersonID = (requestParams.containsKey("salespersonid")) ? ((String[])requestParams.get("salespersonid"))[0] : "";
	String salesPersonName = (requestParams.containsKey("salespersonname")) ? ((String[])requestParams.get("salespersonname"))[0] : "";
	String locationID = (requestParams.containsKey("customerlocationid")) ? ((String[])requestParams.get("customerlocationid"))[0] : "";
	String locationName = (requestParams.containsKey("customerlocationname")) ? ((String[])requestParams.get("customerlocationname"))[0] : "";
	String newProjectStatusStr = (requestParams.containsKey("newprojectstatus")) ? ((String[])requestParams.get("newprojectstatus"))[0] : "";
	String[] attributes = (requestParams.containsKey("attribute")) ? ((String[])requestParams.get("attribute")) : null;
	String userUnitsStr = (requestParams.containsKey("userunits")) ? ((String[])requestParams.get("userunits"))[0] : "";
	boolean convertToUserUnits = userUnitsStr.equalsIgnoreCase("1");
	String forceAutonamingOffStr = (requestParams.containsKey("forceautonamingoff")) ? ((String[])requestParams.get("forceautonamingoff"))[0] : "";
	boolean forceAutonamingOff = forceAutonamingOffStr.equalsIgnoreCase("1");		
	if (projectName != null) forceAutonamingOff = true;
	Timestamp dueDate = null;
	String dueDateStr = (requestParams.containsKey("duedate")) ? ((String[])requestParams.get("duedate"))[0] : "";
	if (dueDateStr.length() > 0) 
	{
		try 
		{
			dueDate = new Timestamp(Long.parseLong(dueDateStr.trim()));
		}
		catch (Exception ex)
		{
			out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Due date has to be specified as a number of milliseconds from 1.1.1970."));
			checkLogOff(session);
			return;
		}
	}
	else
	{
		// JANH 23.8.2012: check deprecated parameter value (for back compatibility with early builds of WCR 12)
		dueDateStr = (requestParams.containsKey("projectdduedate")) ? ((String[])requestParams.get("projectdduedate"))[0] : "";
		if (dueDateStr.length() > 0) 
		{
			String DATE_FORMAT = "yyyyMMdd";
			SimpleDateFormat sdfOut = new SimpleDateFormat(DATE_FORMAT);
			java.util.Date dateA = sdfOut.parse(dueDateStr);
			
			Calendar cal = Calendar.getInstance();
			cal.setTime(dateA);
			
			Calendar currentCal = Calendar.getInstance(); //today
			currentCal.set(Calendar.DAY_OF_YEAR, cal.get(Calendar.DAY_OF_YEAR));
			currentCal.set(Calendar.YEAR, cal.get(Calendar.YEAR));
			currentCal.set(Calendar.MONTH, cal.get(Calendar.MONTH));
			
			dueDate = new Timestamp(currentCal.getTimeInMillis());
		}
	}
	
	//DT104040 - need to omit some inactive project modification checks in the case of creating new project. The default value is 1 - check is ON
	int checkSecSettingForNonActiveProject = 1;
	
	// process action parameter
	boolean createAction = false;
	if (action != null)
	{
		action = action.trim();
		if (!action.equalsIgnoreCase(ACTION_CREATE) && !action.equalsIgnoreCase(ACTION_MODIFY))
		{
			out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Valid values for 'action' parameter are: 'create', 'modify'."));
			checkLogOff(session);
			return;
		}
		if (action.equalsIgnoreCase(ACTION_CREATE))
			createAction = true;
	}
	else action = "";
	
	// create the ejb
	ProjectMgrTM projectMgrTM = DBTMUtils.findBean(response, session, ProjectMgrTM.class);
	ProjectTM projectTM = DBTMUtils.findBean(response, session, ProjectTM.class);
	UserTM userTM = DBTMUtils.findBean(response, session, UserTM.class);
	GroupTM groupTM = DBTMUtils.findBean(response, session, GroupTM.class);
	CompanyTM companyTM = DBTMUtils.findBean(response, session, CompanyTM.class);
	LocationTM locationTM = DBTMUtils.findBean(response, session, LocationTM.class);

	if ((projectTM == null) || (projectMgrTM == null) || (userTM == null) || (groupTM == null) || 
			(companyTM == null) || (locationTM == null)) 
	{
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);
		return;
	}

	// process specified source project/template parameters
	String sourceProjectID = projectTemplateID;
	String sourceProjectName = projectTemplateName;
	boolean isSourceProjTemplate = true;
	// template has precedence over copy project
	if ((sourceProjectID.length() == 0) && (sourceProjectName.length() == 0))
	{
		sourceProjectID = copyProjectID;
		sourceProjectName = copyProjectName;
		isSourceProjTemplate = false;
	}

	Project project = null;
	Project originalProject = null;
	boolean isNewProjectCreated = false;
	boolean updatedExistingProject = false;
	Project templateProject = null;
	
	// first try to load source project / template if specified
	if ((sourceProjectID.length() > 0) || (sourceProjectName.length() > 0))
	{
		try
		{
			templateProject = loadTemplate(loginID, projectTM, sourceProjectID, sourceProjectName);
			if ((templateProject == null) || templateProject.isDeleted() || !templateProject.isLoaded())
			{
				out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_PROJ_TEMPL, "Cannot load specified template / source project."));
				checkLogOff(session);
				return;
			} else if (isSourceProjTemplate && !templateProject.isTemplate()) {
				out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_PROJ_TEMPL, "Cannot load specified template."));
				checkLogOff(session);
				return;				
			}	
			
			// check whether the user has visibility on the template
			if (isSourceProjTemplate && !projectMgrTM.isTemplateVisible(loginID,templateProject))
			{
				out.write(SDKUtils.ShowError(SDKUtils.SDK_NOT_ALLOWED, "You do not have access to the specified template."));
				checkLogOff(session);
				return;					
			}			
		}
		catch (WebCenterRemoteException ex) 
		{
			// template/project with given ID/name is invalid (template cannot be loaded) - return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_PROJ_TEMPL, "Cannot load specified template / source project."));
			checkLogOff(session);
			return;
		}
	}
	
	boolean projectAutoName = false;
	boolean projectAutoNameEditField = false;
	if (createAction)
	{
		projectAutoName = !forceAutonamingOff && ProjDetailsUtils.useProjectAutoNaming(session, response, sourceProjectID, sourceProjectName); 
		if (projectAutoName)
		{
			projectAutoNameEditField = ProjDetailsUtils.useProjectAutoNamingEditField(session, response, sourceProjectID, sourceProjectName); 
		}
	}
	
	// mandatory parameters checks
	if (!projectAutoName)
	{
		if ((projectName == null || projectName.length() == 0) && (projectID == null))
		{
			// not mandatory when the project gets created based on a project where the autoname option is set on 
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
	}

	// try to load project by specified ID or name to find out whether the project exists...
	try 
	{
		// check whether the project with specified ID/name already exists
		if (!action.equalsIgnoreCase(ACTION_CREATE) && (projectID != null))
		{
			project = projectTM.findById(loginID, projectID);
		}
		else if (projectName != null && projectName.length() > 0 && !projectAutoName)
		{
			project = projectTM.findByName(loginID, projectName);
		}		
		
		//no project was found, thus the project is created and not edited, thus I want to omit the security check relevant for non-active project modification
		if (project == null) {
			checkSecSettingForNonActiveProject = 0;
		} else {
			//need to keep the original Project state for later comparison
			originalProject = project.clone(project);
		}
	}
	catch (WebCenterRemoteException ex) 
	{
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
		checkLogOff(session);
		return;
	}
	
	// handle a new project manager (if entered)
	if ((managerID.length() == 0) && (managerName.length() == 0))
	{
		// no particular project manager specified. perform an action based on project existence
		if (project == null)
		{
			// project doesn't exist - use the current SDK caller as a project manager
			// GRBO: fine-tune this algorithm: when the template has a group as PM, and the SDK caller is part of this group,
			// 			then the group remains the PM of the new project
			String sdkCallerID = LoginMgr.getLoginMgr(session).getLoginUserID();
			managerID = sdkCallerID;
			isMgrGroup = false;
			
			// check the template's group manager 
			if (templateProject != null && templateProject.isGroupPM())
			{
				String templateManagerID = templateProject.getManagerID();
				// load all members of the template group manager
				Vector<UserInGroup> templateManagerUsers = groupTM.loadUserList(loginID, templateManagerID, null);
				Vector<String> templateManagerUserIDs = UserInGroup.getUserIDsFromVector(templateManagerUsers);
				if (templateManagerUserIDs.contains(sdkCallerID))
				{
					// the project manager becomes the group manager of template that contains the SDK caller as a member
					managerID = templateManagerID;
					isMgrGroup = true;
				}
				// else the project manager is the SDK caller (always a user)
			}
		}
		else
		{
			// project already exists - leave the current project manager
			managerID = project.getManagerID();
			isMgrGroup = project.isGroupPM();
		}
	}
	else
	{
		// a particular user/group is named to be project manager of created/modified project
		String foundMgrID = "";
		try
		{		
			// find the user/group (new PM)
			if (isMgrGroup)
			{
				// manager is a group
				Group manager = null;
				if (managerID.length() > 0) manager = groupTM.findById(loginID, managerID);
				else if (managerName.length() > 0) manager = groupTM.findGroupByName(loginID, managerName);
				if ((manager != null) && !manager.isDeleted()) foundMgrID = manager.getObjectID();
			}
			else
			{
				// manager is a user
				// GRBO: in case of AE -> WC, the user/group flag is not set. wow we will never get into the first part. (where the manager is a group)
				// So, to cover the case where nothing is set (isMgrGroupStr == empty string), we check whether the given 'manager' is a group
				User manager = null;
				if (managerID.length() > 0) manager = userTM.findById(loginID, managerID);
				else if (managerName.length() > 0) manager = userTM.findUserByCompanyNameAndUserName(loginID, null, managerName);
				if ((manager != null) && !manager.isDeleted()) 
				{
					foundMgrID = manager.getObjectID();
				}
				else if (isMgrGroupStr.equalsIgnoreCase("")) // when it is not specified whether the manager is a group/user, try to figure out whether he is a group
				{
					Group managerGroup = null;
					if (managerID.length() > 0) managerGroup = groupTM.findById(loginID, managerID);
					else if (managerName.length() > 0) managerGroup = groupTM.findGroupByName(loginID, managerName);
					if ((managerGroup != null) && !managerGroup.isDeleted())
					{
						foundMgrID = managerGroup.getObjectID();
						isMgrGroup = true;
					}
				}
			}
			
			// check that specified manager was found
			if (foundMgrID.length() > 0) {
				managerID = foundMgrID;
			}
			else {
				if (isMgrGroup) {
					out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_GROUP, "Specified project manager cannot be set."));
				}
				else {
					out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER, "Specified project manager cannot be set."));
				}		
				checkLogOff(session);
				return;
			}
			
			// look for the current PM dependencies (ongoing approval cycle, task assignee) - not for create action and if really changed
			if (!createAction && project != null && project.getManagerID() != null && !project.getManagerID().equalsIgnoreCase(managerID)) {
				// throws DeleteMemberException
				if (!ProjMgmntUtils.canReassignProjectManager(response, session, project.getObjectID())) { 
					out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR)); 
					checkLogOff(session); 
					return;
				}
			}
			// check that the specified user/group can be assigned as PM
			// throws IllegalArgumentException
			if (!ProjMgmntUtils.canAssignAsProjectManager(response, session, managerID, isMgrGroup)) {
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR)); 
				checkLogOff(session); 
				return;	
			}
		}
		catch (DeleteMemberException ex) {
			out.write(SDKUtils.ShowErrorTag(SDKUtils.SDK_NOT_ALLOWED, ex.getMessageLangString()));
			checkLogOff(session);
			return;			
		}
		catch (IllegalArgumentException ex) {
			// message contains the lang. tag
			out.write(SDKUtils.ShowErrorTag(SDKUtils.SDK_NOT_ALLOWED, ex.getMessage()));
			checkLogOff(session);
			return;			
		}		
		catch (WebCenterRemoteException ex) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
			checkLogOff(session);
			return;
		}
	}

	// process specified customer (company) and its location
	if ((companyID.length() > 0) || (companyName.length() > 0) || (companyShortName.length() > 0))
	{
		try
		{
			boolean legalNameAndLocationMatchRun = false;
			
			//--------------------------------------------------------
			// get company and locatio ID values
			Company company = null;
			Location location = null;
			
			if (companyID.length() > 0) {
				//ID is unique > has to be a specific Company
				company = companyTM.findByIdLocal(companyID);
			} else if (companyShortName.length() > 0) {
				//ShortName is unique > has to be a specific Company
				company = companyTM.findByName(loginID, companyShortName);
			} else if (companyName.length() > 0) {
				//LegalName is not unique > can be multiple Companies - if LocationName was supplied try to match on both
				//otherwise fallback to the "match to a single Company by LegalName"
				if (locationName.length() > 0) {
					//Location Name was supplied
					boolean doSaveCompanyLocation = false;		
					
					//first load all Companies that match the LegalName
					Vector<Company> companiesList = companyTM.findCompaniesByLegalName(loginID, companyName);
					if (!VectorUtils.isEmptyOrNull(companiesList)) {
						//now try to find the first Company that matches the supplied Location Name
						for (Company curCompany : companiesList) {
							location = locationTM.findByNameAndCompany(loginID, locationName, curCompany.getObjectID());
							if (location != null && location.isLoaded()) {
								//found a match > we can finish the search already
								companyID = curCompany.getObjectID();
								locationID = location.getObjectID();
								legalNameAndLocationMatchRun = true;
								break;
							}
						}
						
						//we found (at least one) a matching Company, but no further match with a Location (by Name)
						//--> create a new Location in the existing Company (if more Companies matched the LegalName, use the first one in the list)
						if (!legalNameAndLocationMatchRun) {
							company = companiesList.get(0);
							
							location = new Location();
							location.setName(locationName);
							company.getLocationList().add(location);
							legalNameAndLocationMatchRun = true;
							doSaveCompanyLocation = true;
						}
					}

					//in case the matching failed > attempt to create a new Company+Location 
					if (!legalNameAndLocationMatchRun) {
						//prepare a new Company+Location object to get created
						company = new Company();
						company.setName(companyName);
						company.setLegalName(companyName);
						
						location = new Location();
						Vector<Location> newCompanyLocList = new Vector<Location> (1);
						location.setName(locationName);
						newCompanyLocList.add(location);
						company.setLocationList(newCompanyLocList);
						legalNameAndLocationMatchRun = true;
						doSaveCompanyLocation = true;
					}
					
					// save the new company into database (this requires Admin rights!)
					if (doSaveCompanyLocation) {
						try {
							company = companyTM.save(loginID, company);
							
							//and update the ID references for use for the new Project to be created
							companyID = company.getObjectID();
							location = locationTM.findByNameAndCompany(loginID, locationName, companyID);
							if (location == null || !location.isLoaded()) {
								//Location couldnt be loaded > ERROR!
								out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_LOCATION));
								checkLogOff(session);
								return;	
							}
							locationID = location.getObjectID();
							
						}
						catch (WebCenterRemoteException ejbEx) 	{
							LogMgr.getLogger().log(Level.SEVERE, "Error: companyTM.save Details: " + ejbEx.toString());
							out.write(SDKUtils.ShowError(SDKUtils.SDK_NOT_ALLOWED, ejbEx));
							checkLogOff(session);
							return;
						}
					}

				} else {
					//Location Name was not supplied > use original logic (get first matching Company by LegalName)
					company = companyTM.findByLegalName(loginID, companyName);	
				}
			}
			
			//if we haven't found a LegalName+LocationName match (only tried if those two parameters were explicetly supplied) 
			//--> make further checks
			if (!legalNameAndLocationMatchRun) {
				//No Company? By now it should already be initialized > ERROR!
				if ((company == null) || !company.isLoaded())
				{
					out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_COMPANY));
					checkLogOff(session);
					return;
				}
				
				// Customer's Company was found
				companyID = company.getObjectID();

				//---------------------------------------------------------
				// prepare Company's Locations for the subsequent algorithm
				Vector<Location> locList = companyTM.loadLocations(loginID, companyID);
				if ((locList == null) || (locList.size() == 0))
				{
					//JANH should not happend
					out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, "Specified company has no location assigned."));
					checkLogOff(session);
					return;
				}

				// get location's ID
				if (locationID.length() > 0) 
				{
					if ((location = locationTM.findById(loginID, locationID)) != null)
					{
						// check that found location belongs to specified company (customer)
						boolean locationFound = false;
						for (int i = 0; i < locList.size(); i++)
						{
							String locID = locList.get(i).getObjectID();
							if (locationID.equalsIgnoreCase(locID))
							{
								locationFound = true;
								break;
							}
						}
						// when locationID specified by SDK caller does not correspond to any of the company's locations
						// a not existing location (for given company) was specified - return appropriate error.
						if (!locationFound) location = null;
					}
				}
				else if (locationName.length() > 0) 
				{
					location = locationTM.findByNameAndCompany(loginID, locationName, companyID);
				}
				
				//---------------------------------------------------------
				//final validation
				if ((locationID.length() > 0) || (locationName.length() > 0))
				{
					// if Location reference was supplied as a request parameter > make sure it was validated by now
					if (location == null)
					{
						//Location couldnt be loaded > ERROR!
						out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_LOCATION));
						checkLogOff(session);
						return;
					}
					
					//Location was loaded > update the reference ID
					locationID = location.getObjectID();
				}
				else 
				{
					// no particular location entered > just use the first one from the Company's Locations list
					locationID = ((Location)locList.get(0)).getObjectID();
				}
			}
		}
		catch (WebCenterRemoteException ex) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
			checkLogOff(session);
			return;
		}
	}
	else
	{
		// BVON: Try to take customer from template
		if (templateProject == null)
		{
			// customer (company/location) was not specified - do not set/change it in the project
			companyID = null;
			locationID = null;
		}
		else
		{
			companyID = templateProject.getCustomerID();
			locationID = templateProject.getLocationID();
		}
	}
	
	//handle the requested SalesPerson reference
	String salesPersonUserID = "";
	if ((StringUtils.checkForValue(salesPersonID)) || (StringUtils.checkForValue(salesPersonName)))
	{
		
		User salesPersonUser = null;
		
		//load the Sales Person User object
		if (StringUtils.checkForValue(salesPersonID)) {//try getting with the ID first
			salesPersonUser = userTM.findById(loginID, salesPersonID);
		} else {// go with Username instead
			salesPersonUser = userTM.findByUsername(loginID, salesPersonName);
		}
		
		if (salesPersonUser == null) { // couldnt load? >>> shouldnt happen
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER, "Specified Sales Person reference does not match any existing User."));
			checkLogOff(session);
			return;
		} else {
			salesPersonUserID = salesPersonUser.getObjectID();
		}
	}
	
	//-------------------------------------------------------------
	//PARAMETER PARSING COMPLETE >>> GOT TO: EXECUTE THE ACTIONS
	//-------------------------------------------------------------

	// Algorithm:
	// 1. if specified projectID/Name exists, load the existing project and modify it (ignoring template).
	// 2. if it doesn't exist and projectName is specified, create a new project with the given name (ignoring projectID).
	// 2.1. if projectTemplateID/Name is specified, use that template to create the new project. if no such
	// template exists return an error.
	// 2.2. if template is not specified, create a new blank project.
	//
	// - "action" parameter (possible values: "create", "modify") determines which operations are valid.
	// When not specified and an unused projectName is specified a new project is created, 
	// otherwise existing project is modified/updated or an error is generated.
	// - It's not possible to create a new project with specified projectID.
	
	if (project != null)
	{
		// if given project already exists, try to update it only
		if (action.equalsIgnoreCase(ACTION_CREATE))
		{
			// when explicitely set to create a new project and the given project name is in use, return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PROJECT_EXISTS));
			checkLogOff(session);
			return;
		} 
		else if (project.isDeleted()) {
			// we should not allow any operations on a deleted project
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_PROJECT));
			checkLogOff(session);
			return;			
		}
		// (the project update is done almost at the end of the file)
	}
	else
	{
		// specified project does not exist - create a new one
		if (action.equalsIgnoreCase(ACTION_MODIFY))
		{
			// when explicitely set to modify existing project, return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_PROJECT));
			checkLogOff(session);
			return;
		}
		
		if ((sourceProjectID.length() > 0) || (sourceProjectName.length() > 0))
		{
			// set verified source project ID
			sourceProjectID = templateProject.getObjectID();
			
			// having template (or source project) utilize it to create a new project
			try
			{
				// check whether the name needs to be auto-generated 
				projectName = resolveName(projectName, request, response, session, companyID, locationID, 
						managerID, isMgrGroup, requestParams, sourceProjectID, projectNameSuffix, attributes, projectAutoName);

				CopyProject copyFromProject = new CopyProject();
				copyFromProject.setCopyAll();
				copyFromProject.setFromProjectID(sourceProjectID);
				copyFromProject.setProjectName(projectName);
				copyFromProject.setProjectDesc(projectDesc);
				
				if (isSourceProjTemplate)
				{
					// create a new project using specified template
					project = projectMgrTM.createProjectFromTemplate(loginID, copyFromProject);
					//JANH as long as the SDK doesn't have option to specify task planning (forward/backward) the default
					// behavior is forward planning with the first task starting at time of project creation, so the 
					// below line of code is not needed!
					//	project = projectMgrTM.createProjectFromTemplate(loginID, copyFromProject, shiftOption, ts2, timezoneOffsetMillis);
				}
				else
				{
					// create a new project as copy of existing "source" project
					project = projectMgrTM.copyProjectFromAnotherProject(loginID, copyFromProject);
				}
				
				// now generate view data for all supported doctypes and documents in the created project
				if (!ProjDetailsUtils.generateProjectViewData(response, request, session, project.getObjectID()))
				{
					out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, "View Data Generation error"));
					checkLogOff(session);
					return;
				}
				
				isNewProjectCreated = true;
			}
			catch (WebCenterRemoteException ex)
			{
				out.write(SDKUtils.ShowError(SDKUtils.SDK_PROJ_FAILED, ex));
				checkLogOff(session);
				return;   // exit here
			}
		}
		else
		{
			// create a blank project
			// check whether the name needs to be auto-generated 
			projectName = resolveName(projectName, request, response, session, companyID, locationID, managerID, 
					isMgrGroup, requestParams, null, projectNameSuffix, attributes, projectAutoName);
			
			// create a new project from scratch
			project = new Project();
			project.setName(projectName);
			// (the rest of project parameters is set below)
			
		  isNewProjectCreated = true;
	  }
	}

	//---------------------------------------------------------
	// Update the existing project by specified SDK parameters. 
	// NOTE: if any parameter is null, its original value is kept
	//---------------------------------------------------------
	if (managerID != null) 
	{ 
		project.setManagerID(managerID);
		project.setIsGroupPM(isMgrGroup);
	}
	if (projectNewName.length() > 0) {
		// allow explicit project renaming even if autonaming is turned on! (It's in line with current GUI)
		project.setName(projectNewName);
	}
	if (projectDesc != null) project.setDescription(projectDesc);
	if (companyID != null) project.setCustomerID(companyID);
	if (locationID != null) project.setLocationID(locationID);
	if (dueDate != null) project.setDueDate(dueDate);
	if (StringUtils.checkForValue(salesPersonUserID)) project.setSalespersonID(salesPersonUserID);

	// figure out the initial status of the project. First tries to get it from parameters, if no success then
	// tries to get first active, if no success tries to get first from the statuses selected for project.
	// if no success the initial status is set to the first project status in the project.
	String newProjectStatusID = null;
	if ((newProjectStatusStr.length() > 0) || isNewProjectCreated)
	{
		Vector<CustomProjectStatus> customProjStatusList = null;
		if (project.isLoaded()) 
		{
			// when project already exists (all cases except "crate blank project") try to load its project statuses
			customProjStatusList = projectMgrTM.loadProjectStatusesListForProject(loginID, project.getObjectID(),
					ProjectStatusesCache.getInstance().getDBObjectsMapCache(response, session));
		}
		if (VectorUtils.isEmptyOrNull(customProjStatusList))
		{
			// there are no project statuses in the project - load the system ones
			customProjStatusList = ProjectStatusesCache.getInstance().getDBObjectsCache(response, session);
		}

		if (!VectorUtils.isEmptyOrNull(customProjStatusList))
		{
			if (newProjectStatusStr.length() > 0) 
			{
				// check whether specified project status name can be recognized
				for (CustomProjectStatus projStatus : customProjStatusList) 
				{
					if (newProjectStatusStr.equalsIgnoreCase(projStatus.getStatusName())) 
					{
						newProjectStatusID = projStatus.getObjectID();
						break;
					}
				}
				if (newProjectStatusID == null)
				{
					out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Specified project status cannot be found"));
					checkLogOff(session);
					return;
				}
			}
			else
			{
				// if no explicit project status specified (via SDK parameter), select the first active project status
				for (CustomProjectStatus projStatus : customProjStatusList) 
				{
					if (projStatus.isIsActive()) 
					{
						newProjectStatusID = projStatus.getObjectID();
						break;
					}
				}
				if (newProjectStatusID == null) 
				{
					// if no active status in the project/system select the first one
					newProjectStatusID = customProjStatusList.get(0).getObjectID();
				}
			}
		}
	}
	// finally set the initial project status
	if (StringUtils.checkForValue(newProjectStatusID)) project.setStatusID(newProjectStatusID);

	// finally save modified (or newly created blank) project into database
	if (project.isModified())
	{
		try
		{		  
			//update existing Project or save newly created Project
		  	//NOTE: passing originalProject (can be null > only initialized when updating an existing Project) in order to authorize PM-only operations
		  	project = projectTM.save(loginID, project, originalProject, checkSecSettingForNonActiveProject);
		
			if (!isNewProjectCreated) {
				updatedExistingProject = true;
			}
		}
		catch (WebCenterRemoteException ex)
		{
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PROJ_FAILED, ex));
			checkLogOff(session);
			return;
		}
	}
	
	// Make sure the project status is written in the project history for a new project
	projectMgrTM.writeCreatedStatusProjectHistory(loginID, project);
		
	// get the list of attributes from the request and apply them on the project
	if (attributes != null)
	{
		// create the bean 
		AttributeTM attributeTM = DBTMUtils.findBean(response, session, AttributeTM.class);

		// process the string of attribute {name:value} pairs and return {ID:value} pairs
		// also return {name:value} string pairs datastructure for role assignment support
		Vector<String[]> attrNameValueStringPairs = new Vector<String[]>();
		AttrValuesContainer processedAttrs = SDKUtils.
				convertAttrKeyValuePairsString(session, response, attributeTM, attributes, project.getObjectID(), convertToUserUnits, attrNameValueStringPairs);
		
		// store the processed attribute values in the project's attributes
		for (String attrId : processedAttrs.getAttrValuesKeySet()) {
			ProjectAttribute projectAttribute = new ProjectAttribute();
			projectAttribute.copy(processedAttrs.getAttrValue(attrId));
			projectAttribute.setProjectID(project.getObjectID());
			projectAttribute.setAttributeID(attrId);

			attributeTM.saveProjectAttribute(loginID, projectAttribute);
		}

		// do the assignment based on the given values, so that they don't need to be attributes to get mapped
		projectMgrTM.assignRolesWithValues(loginID, project.getObjectID(), attrNameValueStringPairs);
	}


	//----------------------------------------------------------------
	//handle e-mail notifications + execute post create/update actions
	//----------------------------------------------------------------
	ProjectNotificationMgr notificationMgr = new ProjectNotificationMgr(response, session, request);
	
	if (isNewProjectCreated)
	{
		projectID = project.getObjectID();
		
		// send email notification to project members	
		Vector<ProjectUserMember> userMembers = null;
		Vector<ProjectGroupMember> groupMembers = null;
		try {
			// load all User Members of the Project
			userMembers = projectTM.loadProjectUserMembers(loginID,	projectID, null);

			// load all Group members of the Project
			groupMembers = projectTM.loadProjectGroupMembers(loginID,projectID, null);
		} catch (Exception ex) {
			LogUtils.LogSDK(request, session, "CreateProject.jsp: Loading Members of a new Project (Project ID =" + projectID + ") failed. Exception: " + ex.getMessage());
		}

		if (!VectorUtils.isEmptyOrNull(userMembers) || !VectorUtils.isEmptyOrNull(groupMembers)) {
			// retrieve the User and Group member IDs
			Vector<String> memberUserIDs = null;
			Vector<String> memberGroupIDs = null;

			if (!VectorUtils.isEmptyOrNull(userMembers)) {
				memberUserIDs = ProjectUserMember.getUserIDs(userMembers);
			}

			if (!VectorUtils.isEmptyOrNull(groupMembers)) {
				memberGroupIDs = ProjectGroupMember.getGroupExtendedIDs(groupMembers);
			}
			
			try 
			{
				// send out the 'Members Invited' notifications
				notificationMgr.NotifyOnMemberInvitedToProject(loginID, projectID, memberUserIDs, memberGroupIDs);
			}
			catch (Exception ex) {
				LogUtils.LogSDK(request, session, "CreateProject.jsp: Notification on new member invitation to project with ID " + projectID + "failed. Exception: " + ex.getMessage());
			}
		}
		
		// finally the whole new project is created -> try starting all tasks set to start automatically
		// after project creation (if any)
		projectMgrTM.startProjectTasksAfterProjectCreation(projectID);
				
		//JANH what is still missing:
		// - REQUESTOR group support
		// - AE Workflow connection (submission of the new project to AE workflow) [not clear what's needed]
		// - BOM handling (saveBOMCountAndAttributes() method call?!)
		// - Notification of task assignees in the new project when the project is created from an existing project
		// - ProjectMgrTMBean.restoreProjectManagerFromSourceProject() method call - not sure if it should be added!?
	} else if (updatedExistingProject && project != null && originalProject != null) {
		//Project was Updated > check if we need to send out some e-mail notifications
		
		boolean isGenInfoChanged = !project.getName().equals(originalProject.getName())
					|| !project.getDescription().equals(originalProject.getDescription());

		boolean isStatusChanged = !project.getStatusID().equals(originalProject.getStatusID());
		
		boolean	isDueDateChanged = project.getDueDate() != null
					&& !project.getDueDate().equals(originalProject.getDueDate());
		
		// send notification if Project Name and/or Description
		if (isGenInfoChanged) {
			notificationMgr.NotifyOnProjectInfoChange(loginID, project.getObjectID(), project.getName(),
					project.getDescription());
		}

		// send notification if Project Status was changed
		if (isStatusChanged) {
			notificationMgr.NotifyOnProjectStatusChange(loginID, project.getObjectID());
			
			// if Project Status was changed from non-active to active
			Hashtable<String, CustomProjectStatus> projStatusesMap = ProjectStatusesCache.getInstance()
				.getDBObjectsMapCache(response, session);
			boolean wasNonActiveProject = !originalProject.isProjectStatusActive(projStatusesMap);
			boolean isActiveProjectNow = project.isProjectStatusActive(projStatusesMap);
			if (wasNonActiveProject && isActiveProjectNow) {
				// also notify all Project Members that they are invited to the Project
				ProjDetailsUtils.notifyAllProjectMembersOnInvite(response, request, session, project.getObjectID());
			}
		}

		// send notification if Project Due Date was changed
		if (isDueDateChanged) {
			notificationMgr.NotifyOnProjectDueDateChange(loginID, project.getObjectID());
		}
	}
	
	// generate output - modified or created project ID
	out.write("<projectID>" + project.getObjectID() + "</projectID>");

	checkLogOff(session);
%>
<%!
	public String resolveName(String projectName, HttpServletRequest request, HttpServletResponse response, HttpSession session, String companyID , String locationID, 
		String managerID , boolean isMgrGroup , Properties requestParams, String sourceProjID, String projectNameSuffix, String[] attributes, boolean projectAutoName) throws Exception{
		if (projectAutoName){
			Properties requestProps = ProjDetailsUtils.getRequestParamsAsSmartnames(response, session,companyID ,locationID, managerID , isMgrGroup ,requestParams );
			// add the template id 
			if (sourceProjID != null) requestProps.put( "projectid",sourceProjID);
			if(projectNameSuffix != null && projectNameSuffix.length()>0)
				requestProps.put("projectnameeditfield",projectNameSuffix);
			Properties attributeProperties = ProjDetailsUtils.getAttributesInProperties(response, request, 
		 		session, sourceProjID, attributes);	
			String resolvedProjectName = ProjDetailsUtils.resolveProjectSmartname(response, session , requestProps, attributeProperties);
			if (resolvedProjectName!=null)
				projectName = resolvedProjectName;
		}
		return projectName;
	}

%>
<%!
	public Project loadTemplate(String loginID, ProjectTM projectTM, String sourceProjectID, String sourceProjectName) 
	throws WebCenterRemoteException 
	{
		if ((sourceProjectID != null) &&  (sourceProjectID.length() > 0))
		{
			return projectTM.findById(loginID, sourceProjectID);
		}
		else if ((sourceProjectName != null) && (sourceProjectName.length() > 0))
		{
			return projectTM.findByName(loginID, sourceProjectName);
		}
		return null;
	}
%>

